package com.paint.ar.drawing.activity;

import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.content.ContextCompat;
import androidx.fragment.app.Fragment;
import androidx.viewpager2.adapter.FragmentStateAdapter;
import androidx.viewpager2.widget.ViewPager2;

import com.google.android.material.tabs.TabLayout;
import com.paint.ar.drawing.MyApp;
import com.paint.ar.drawing.R;
import com.paint.ar.drawing.databinding.ActivityMainBinding;
import com.paint.ar.drawing.fragment.FragmentAlbum;
import com.paint.ar.drawing.fragment.FragmentLike;
import com.paint.ar.drawing.fragment.MainFragment;
import com.paint.ar.drawing.helper.Utils;
import com.paint.ar.drawing.topon.AdManager;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class MainActivity extends AppCompatActivity {

    private ActivityMainBinding binding;

    private List<Fragment> listFragment = new ArrayList<>();

    private   FragmentAlbum fragmentAlbum;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        Utils.setStatusBarTextColor(this,true);
        binding = ActivityMainBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        AdManager.loadAllAd();
         fragmentAlbum = FragmentAlbum.newInstance();
        listFragment.add(MainFragment.newInstance());
        listFragment.add(fragmentAlbum);
        listFragment.add(FragmentLike.newInstance());

        onTabInit();
        binding.viewPager2.setUserInputEnabled(false);
        binding.viewPager2.setAdapter(new FragmentStateAdapter(this) {
            @NonNull
            @Override
            public Fragment createFragment(int position) {
                return listFragment.get(position);
            }

            @Override
            public int getItemCount() {
                return listFragment.size();
            }
        });
        bingTabVp();

    }



    private void bingTabVp() {
        binding.tab.addOnTabSelectedListener(new TabLayout.OnTabSelectedListener() {
            @Override
            public void onTabSelected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(true);
                binding.viewPager2.setCurrentItem(tab.getPosition());
            }

            @Override
            public void onTabUnselected(TabLayout.Tab tab) {
                ImageView icon = Objects.requireNonNull(tab.getCustomView()).findViewById(R.id.im_icon);
                icon.setSelected(false);
            }

            @Override
            public void onTabReselected(TabLayout.Tab tab) {

            }
        });
        binding.viewPager2.registerOnPageChangeCallback(new ViewPager2.OnPageChangeCallback() {
            @Override
            public void onPageSelected(int position) {
                super.onPageSelected(position);
                Objects.requireNonNull(binding.tab.getTabAt(position)).select();
            }
        });
    }


    private void onTabInit() {

        for (int i = 0; i < listFragment.size(); i++) {
            TabLayout.Tab tab = binding.tab.newTab();

            View inflate = LayoutInflater.from(this).inflate(R.layout.item_tab_view, null, false);
            ImageView icon = inflate.findViewById(R.id.im_icon);
//            TextView textView = inflate.findViewById(R.id.textView);
            if (i == 0) {
//                textView.setText(getString(R.string.tv_home));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_tab));
            } else if(i ==2){
//                textView.setText(getString(R.string.tv_like));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_like));
            }else {
//                textView.setText(getString(R.string.tv_album));
                icon.setImageDrawable(ContextCompat.getDrawable(this, R.drawable.selector_album));
            }
            tab.setCustomView(inflate);
            binding.tab.addTab(tab);
        }

    }

//    @Override
//    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
//        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
//        if (requestCode == 0) {
//            Log.d(MyApp.TAG,"----------onRequestPermissionsResult-");
//            fragmentAlbum.permissionResult();
//        }
//    }
}